import React, {useState} from "react";
import FormToFill from "../../components/FormToFill/FormToFill";
import {createContact} from "../../store/actions";
import {connect} from "react-redux";


const AddContactForm = props => {
    const [contactInfo, setContactInfo] = useState({
        name: '',
        phone: '',
        email: '',
        photo: ''
    });

    const inputHandler = (e) => {
        setContactInfo({
            ...contactInfo,
            [e.target.name]: e.target.value
        })
    };

    const addContact = e => {
        e.preventDefault();
        const contact = {
           ...contactInfo
        };
        props.onContactCreated(contact)

    };


    return (
        <>
            <div>
                <FormToFill
                inputHandler={inputHandler}
                name={contactInfo.name}
                phone={contactInfo.phone}
                email={contactInfo.email}
                photo={contactInfo.photo}
                submit={addContact}
                />
            </div>
        </>
    );
};

const mapDispatchToProps = dispatch => {
    return {
        onContactCreated: (contact) => dispatch(createContact(contact))
    }
};

export default connect(null, mapDispatchToProps)(AddContactForm);
