import React, {Component} from "react";
import {connect} from "react-redux";
import {getContacts} from "../../store/actions";
import Contact from "../../components/Contact/Contact";
import Modal from "../../components/Modal/Modal";
import {NavLink} from "react-router-dom";


class Contacts extends Component {
    state = {
        selectContact: null,
        modalShow: false
    }

    componentDidMount() {
        this.props.getContacts()
    }

    selectHandler = (id) => {
        this.setState({selectContact: id})
    }

    printContacts = () => {
        let contacts = this.props.contacts
        return Object.keys(contacts).map(contact => {
            return <Contact
                select={() => this.selectHandler(contact)}
                name={contacts[contact].name}
                email={contacts[contact].email}
                phone={contacts[contact].phone}
                photo={contacts[contact].photo}
                key={contact}/>
        })
    }

    render() {
        return (
            <>
                {this.props.contacts ? <div className='Contacts'>{this.printContacts()}</div> : null}
                {
                    this.state.selectContact ?
                        <Modal show={true}>
                            <>
                                <div> {this.props.contacts[this.state.selectContact].email} </div>
                                <div> {this.props.contacts[this.state.selectContact].name} </div>
                                <div> {this.props.contacts[this.state.selectContact].phone} </div>
                                <NavLink to={`/contacts/edit/${this.state.selectContact}`}>edit</NavLink>
                            </>
                        </Modal>
                        : null
                }
            </>
        );
    }
}

const mapStateToProps = state => {
    return {
        contacts: state.contacts
    }
};

const mapDispatchToProps = dispatch => {
    return {
        getContacts: () => dispatch(getContacts())
    }
};

export default connect(mapStateToProps, mapDispatchToProps)(Contacts);
